## cubeb 0.0~git20240307.5491fc8+ds

=== debian/changelog ===
cubeb (0.0~git20240307.5491fc8+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20240307.5491fc8+ds
    - Support sound cards running at 384kHz
  * d/s/lintian-overrides: override pkg-config => pkgconf

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 10 Mar 2024 16:13:18 +0100
