=== debian/changelog ===
cubeb (0.0~git20240524.dabff20+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20240524.dabff20+ds
    - Support sound cards running at 768kHz

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sat, 01 Jun 2024 13:57:11 +0200
