## cubeb 0.0~git20250108.048f4a0+ds

=== debian/changelog ===
cubeb (0.0~git20250108.048f4a0+ds-1) unstable; urgency=low

  * New upstream version 0.0~git20250108.048f4a0+ds
  * d/control: apply X-Style: black
  * d/control: declare dpkg-build-api (= 1)

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 12 Jan 2025 00:10:17 +0100
