=== debian/control ===
Source: cubeb
Section: libs
Priority: optional
Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends:
 debhelper-compat (= 13),
 dpkg-build-api (= 1),
 cmake (>= 3.14),
 doxygen <!nodoc>,
 graphviz <!nodoc>,
 libasound2-dev [linux-any],
 libbsd-dev [kfreebsd-any],
 libjack-jackd2-dev,
 libpulse-dev,
 libsndio-dev,
 libspeexdsp-dev,
 pkg-config,
Build-Conflicts:
 libasound2-dev [!linux-any],
Standards-Version: 4.7.0
Homepage: https://github.com/mozilla/cubeb
Vcs-Git: https://salsa.debian.org/debian/cubeb.git
Vcs-Browser: https://salsa.debian.org/debian/cubeb
X-Style: black

Package: libcubeb0
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: cross platform audio library
 cubeb is a cross platform audio library most notable for its use as
 the audio backend within Gecko, Mozilla's browser engine. It supports
 multiple audio backends and allows enumeration of audio devices and
 opening audio streams with control over latency, sample rate and more.
 .
 This package contains the shared library.

Package: libcubeb-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libcubeb0 (= ${binary:Version}),
 libspeexdsp-dev,
 ${misc:Depends},
Recommends:
 libcubeb-doc,
Description: cross platform audio library - development files
 cubeb is a cross platform audio library most notable for its use as
 the audio backend within Gecko, Mozilla's browser engine. It supports
 multiple audio backends and allows enumeration of audio devices and
 opening audio streams with control over latency, sample rate and more.
 .
 This package contains the development files.

Package: libcubeb-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Recommends:
 libjs-jquery,
Description: cross platform audio library - documentation
 cubeb is a cross platform audio library most notable for its use as
 the audio backend within Gecko, Mozilla's browser engine. It supports
 multiple audio backends and allows enumeration of audio devices and
 opening audio streams with control over latency, sample rate and more.
 .
 This package contains the generated Doxygen documentation.
