=== debian/changelog ===
cubeb (0.0~git20250127.2816b5a+ds-1) unstable; urgency=low

  * New upstream version 0.0~git20250127.2816b5a+ds
  * d: document packaging workflow in README.source
  * d/control: set maintainer to my @debian.org address

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 28 Jan 2025 17:41:37 +0100
