## cubeb 0.0~git20250203.224b7cb+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -344,11 +344,12 @@
     cubeb_pulse_rs
     DOWNLOAD_COMMAND ""
     CONFIGURE_COMMAND ""
-    BUILD_COMMAND cargo build --features=gecko-in-tree COMMAND cargo build --release --features=gecko-in-tree
+    BUILD_COMMAND cargo build --features=gecko-in-tree "$<IF:$<CONFIG:Release>,--release,>"
     BUILD_ALWAYS ON
     BINARY_DIR "${PROJECT_SOURCE_DIR}/src/cubeb-pulse-rs"
     INSTALL_COMMAND ""
-    LOG_BUILD ON)
+    LOG_BUILD ON
+    LOG_OUTPUT_ON_FAILURE ON)
   add_dependencies(cubeb cubeb_pulse_rs)
   target_compile_definitions(cubeb PRIVATE USE_PULSE_RUST)
   target_link_libraries(cubeb PRIVATE
@@ -363,11 +364,11 @@
     cubeb_coreaudio_rs
     DOWNLOAD_COMMAND ""
     CONFIGURE_COMMAND ""
-    BUILD_COMMAND cargo build --features=gecko-in-tree COMMAND cargo build --release --features=gecko-in-tree
+    BUILD_COMMAND cargo build --features=gecko-in-tree "$<IF:$<CONFIG:Release>,--release,>"
     BUILD_ALWAYS ON
     BINARY_DIR "${PROJECT_SOURCE_DIR}/src/cubeb-coreaudio-rs"
     INSTALL_COMMAND ""
-    LOG_BUILD ON)
+    LOG_BUILD ON
+    LOG_OUTPUT_ON_FAILURE ON)
   add_dependencies(cubeb cubeb_coreaudio_rs)
   target_compile_definitions(cubeb PRIVATE USE_AUDIOUNIT_RUST)
-  target_link_libraries(cubeb PRIVATE
