=== debian/changelog ===
cubeb (0.0~git20250203.224b7cb+ds-1) unstable; urgency=low

  [ Andrea Pappacoda ]
  * New upstream version 0.0~git20250203.224b7cb+ds

  [ Niels Thykier ]
  * Migrate to debputy (full-integration)

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 09 Feb 2025 18:44:12 +0100
