=== debian/changelog ===
cubeb (0.0~git20250401.975a727+ds-1) unstable; urgency=low

  * New upstream version 0.0~git20250401.975a727+ds

 -- Andrea Pappacoda <tachi@debian.org>  Wed, 09 Apr 2025 15:09:57 +0200
