=== debian/control ===
--- 
+++ 
@@ -2,9 +2,11 @@
 Section: libs
 Priority: optional
 Maintainer: Andrea Pappacoda <tachi@debian.org>
+Build-Driver: debputy
 Build-Depends:
- debhelper-compat (= 13),
+ debputy (>= 0.1.61~),
  dpkg-build-api (= 1),
+ dpkg-dev (>= 1.22.7~),
  cmake (>= 3.14),
  doxygen <!nodoc>,
  graphviz <!nodoc>,
@@ -26,11 +28,6 @@
 Package: libcubeb0
 Architecture: any
 Multi-Arch: same
-Pre-Depends:
- ${misc:Pre-Depends},
-Depends:
- ${misc:Depends},
- ${shlibs:Depends},
 Description: cross platform audio library
  cubeb is a cross platform audio library most notable for its use as
  the audio backend within Gecko, Mozilla's browser engine. It supports
@@ -63,8 +60,6 @@
 Section: doc
 Architecture: all
 Multi-Arch: foreign
-Depends:
- ${misc:Depends},
 Recommends:
  libjs-jquery,
 Description: cross platform audio library - documentation
