=== debian/tests/control ===
Tests:
 compile,
Depends:
 cmake,
 g++ | c++-compiler,
 @,
