=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, repacksuffix=+ds, dversionmangle=auto" \
https://github.com/mozilla/cubeb.git \
HEAD debian uupdate
