## cubeb 0.0~git20250529.78ee5f0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -23,6 +23,17 @@
       "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
 endif()
 
+set(private_requires)
+set(private_libs)
+set(private_libs_flags)
+if(UNIX AND NOT APPLE)
+  if(BSD OR ANDROID)
+    list(APPEND private_libs c++)
+  else()
+    list(APPEND private_libs stdc++)
+  endif()
+endif()
+
 set(CMAKE_C_STANDARD 99)
 set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
@@ -91,7 +102,7 @@
   src/cubeb_utils.cpp
 )
 target_include_directories(cubeb
-  PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include> $<INSTALL_INTERFACE:include>
+  PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include> $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
 )
 set_target_properties(cubeb PROPERTIES
   VERSION ${cubeb_VERSION}
@@ -141,6 +152,7 @@
     pkg_check_modules(speexdsp IMPORTED_TARGET speexdsp)
     if(speexdsp_FOUND)
       add_library(speex ALIAS PkgConfig::speexdsp)
+      list(APPEND private_requires speexdsp)
     endif()
   endif()
 endif()
@@ -155,6 +167,7 @@
     EXPORT=
     RANDOM_PREFIX=speex
   )
+  list(APPEND private_libs speex)
 endif()
 
 # $<BUILD_INTERFACE:> required because of https://gitlab.kitware.com/cmake/cmake/-/issues/15415
@@ -166,6 +179,7 @@
 set(THREADS_PREFER_PTHREAD_FLAG ON)
 find_package(Threads)
 target_link_libraries(cubeb PRIVATE Threads::Threads)
+list(APPEND private_libs ${CMAKE_THREAD_LIBS_INIT})
 
 if(LAZY_LOAD_LIBS)
   check_include_files(pulse/pulseaudio.h USE_PULSE)
@@ -176,6 +190,7 @@
 
   if(USE_PULSE OR USE_ALSA OR USE_JACK OR USE_SNDIO OR USE_AAUDIO)
     target_link_libraries(cubeb PRIVATE ${CMAKE_DL_LIBS})
+    list(APPEND private_libs ${CMAKE_DL_LIBS})
 
     if(ANDROID)
       target_compile_definitions(cubeb PRIVATE __ANDROID_UNAVAILABLE_SYMBOLS_ARE_WEAK__)
@@ -191,6 +206,7 @@
     set(USE_PULSE ON)
     target_compile_definitions(cubeb PRIVATE DISABLE_LIBPULSE_DLOPEN)
     target_link_libraries(cubeb PRIVATE PkgConfig::libpulse)
+    list(APPEND private_requires libpulse)
   endif()
 
   pkg_check_modules(alsa IMPORTED_TARGET alsa)
@@ -198,6 +214,7 @@
     set(USE_ALSA ON)
     target_compile_definitions(cubeb PRIVATE DISABLE_LIBASOUND_DLOPEN)
     target_link_libraries(cubeb PRIVATE PkgConfig::alsa)
+    list(APPEND private_requires alsa)
   endif()
 
   pkg_check_modules(jack IMPORTED_TARGET jack)
@@ -205,18 +222,21 @@
     set(USE_JACK ON)
     target_compile_definitions(cubeb PRIVATE DISABLE_LIBJACK_DLOPEN)
     target_link_libraries(cubeb PRIVATE PkgConfig::jack)
+    list(APPEND private_requires jack)
   endif()
 
   check_include_files(sndio.h USE_SNDIO)
   if(USE_SNDIO)
     target_compile_definitions(cubeb PRIVATE DISABLE_LIBSNDIO_DLOPEN)
     target_link_libraries(cubeb PRIVATE sndio)
+    list(APPEND private_libs sndio)
   endif()
 
   check_include_files(aaudio/AAudio.h USE_AAUDIO)
   if(USE_AAUDIO)
     target_compile_definitions(cubeb PRIVATE DISABLE_LIBAAUDIO_DLOPEN)
     target_link_libraries(cubeb PRIVATE aaudio)
+    list(APPEND private_libs aaudio)
   endif()
 endif()
 
@@ -263,6 +283,7 @@
     src/cubeb_osx_run_loop.cpp)
   target_compile_definitions(cubeb PRIVATE USE_AUDIOUNIT)
   target_link_libraries(cubeb PRIVATE "-framework AudioUnit" "-framework CoreAudio" "-framework CoreServices")
+  list(APPEND private_libs_flags "-framework AudioUnit" "-framework CoreAudio" "-framework CoreServices")
 endif()
 
 check_include_files(audioclient.h USE_WASAPI)
@@ -271,6 +292,7 @@
     src/cubeb_wasapi.cpp)
   target_compile_definitions(cubeb PRIVATE USE_WASAPI)
   target_link_libraries(cubeb PRIVATE avrt ole32 ksuser)
+  list(APPEND private_libs avrt ole32 ksuser)
 endif()
 
 check_include_files("windows.h;mmsystem.h" USE_WINMM)
@@ -279,6 +301,7 @@
     src/cubeb_winmm.c)
   target_compile_definitions(cubeb PRIVATE USE_WINMM)
   target_link_libraries(cubeb PRIVATE winmm)
+  list(APPEND private_libs winmm)
 endif()
 
 check_include_files(SLES/OpenSLES.h USE_OPENSL)
@@ -288,6 +311,7 @@
     src/cubeb-jni.cpp)
   target_compile_definitions(cubeb PRIVATE USE_OPENSL)
   target_link_libraries(cubeb PRIVATE OpenSLES)
+  list(APPEND private_libs OpenSLES)
 endif()
 
 check_include_files(sys/soundcard.h HAVE_SYS_SOUNDCARD_H)
@@ -303,6 +327,7 @@
       pkg_check_modules(libbsd-overlay IMPORTED_TARGET libbsd-overlay)
       if(libbsd-overlay_FOUND)
         target_link_libraries(cubeb PRIVATE PkgConfig::libbsd-overlay)
+        list(APPEND private_requires libbsd-overlay)
         set(HAVE_STRLCPY true)
       endif()
     endif()
@@ -320,6 +345,7 @@
     src/cubeb_audiotrack.c)
   target_compile_definitions(cubeb PRIVATE USE_AUDIOTRACK)
   target_link_libraries(cubeb PRIVATE log)
+  list(APPEND private_libs log)
 endif()
 
 check_include_files(sys/audioio.h USE_SUN)
@@ -335,6 +361,7 @@
     src/cubeb_kai.c)
   target_compile_definitions(cubeb PRIVATE USE_KAI)
   target_link_libraries(cubeb PRIVATE kai)
+  list(APPEND private_libs kai)
 endif()
 
 if(USE_PULSE AND USE_PULSE_RUST)
@@ -348,26 +375,3 @@
     BUILD_ALWAYS ON
     BINARY_DIR "${PROJECT_SOURCE_DIR}/src/cubeb-pulse-rs"
     INSTALL_COMMAND ""
-    LOG_BUILD ON
-    LOG_OUTPUT_ON_FAILURE ON)
-  add_dependencies(cubeb cubeb_pulse_rs)
-  target_compile_definitions(cubeb PRIVATE USE_PULSE_RUST)
-  target_link_libraries(cubeb PRIVATE
-    debug "${PROJECT_SOURCE_DIR}/src/cubeb-pulse-rs/target/debug/libcubeb_pulse.a"
-    optimized "${PROJECT_SOURCE_DIR}/src/cubeb-pulse-rs/target/release/libcubeb_pulse.a" pulse)
-endif()
-
-if(USE_AUDIOUNIT AND USE_AUDIOUNIT_RUST)
-  include(ExternalProject)
-  set_directory_properties(PROPERTIES EP_PREFIX ${CMAKE_BINARY_DIR}/rust)
-  ExternalProject_Add(
-    cubeb_coreaudio_rs
-    DOWNLOAD_COMMAND ""
-    CONFIGURE_COMMAND ""
-    BUILD_COMMAND cargo build --features=gecko-in-tree "$<IF:$<CONFIG:Release,RelWithDebInfo,MinSizeRel>,--release,>"
-    BUILD_ALWAYS ON
-    BINARY_DIR "${PROJECT_SOURCE_DIR}/src/cubeb-coreaudio-rs"
-    INSTALL_COMMAND ""
-    LOG_BUILD ON
-    LOG_OUTPUT_ON_FAILURE ON)
-  add_dependencies(cubeb cubeb_coreaudio_rs)
