=== debian/changelog ===
cubeb (0.0~git20250529.78ee5f0+ds-2) experimental; urgency=low

  * d/debputy.manifest: add missing pkgconfig directory

 -- Andrea Pappacoda <tachi@debian.org>  Tue, 03 Jun 2025 10:11:50 +0200

cubeb (0.0~git20250529.78ee5f0+ds-1) experimental; urgency=low

  * New upstream version 0.0~git20250529.78ee5f0+ds
    - Add pkg-config file generation
    - Add cubeb_get_backend_names

 -- Andrea Pappacoda <tachi@debian.org>  Mon, 02 Jun 2025 15:51:41 +0200
