=== debian/control ===
--- 
+++ 
@@ -19,7 +19,7 @@
  pkg-config,
 Build-Conflicts:
  libasound2-dev [!linux-any],
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/mozilla/cubeb
 Vcs-Git: https://salsa.debian.org/debian/cubeb.git
 Vcs-Browser: https://salsa.debian.org/debian/cubeb
